﻿' ====================================================================
'  This class reads a 16 bit Counter or an Encoder 
' ====================================================================
'  Counter 
'    When increases after 65535 restarts from zero
' ====================================================================
'  Encoder 
'    When increases after 65535 restarts from zero
'    When decreases below 0 restarts from 65535
' ====================================================================

Public Class CounterReader

    Private Const Limit1 As Int32 = 16384
    Private Const Limit2 As Int32 = 49152
    Private Const Limit3 As Int32 = 65536

    Private mSlot As Int32
    Private mNewValue As Int32
    Private mOldValue As Int32
    Private mMaxDelta As Int32 = 500
    Private mValue As Int32

    ' -------------------------------------------------------- call this with a valid slot
    Friend Sub New(ByVal Slot As Int32, ByVal MaxDelta As Int32)
        mSlot = Slot
        mMaxDelta = MaxDelta
        Reset()
    End Sub

    Friend Function ReadValue() As Int32
        mNewValue = CInt(Slots.ReadSlot_NoNan(mSlot))
        If mNewValue <> mOldValue Then
            Dim n As Int32 = mValue + mNewValue - mOldValue
            If mNewValue > Limit2 And mOldValue < Limit1 Then n -= Limit3
            If mNewValue < Limit1 And mOldValue > Limit2 Then n += Limit3
            mOldValue = mNewValue
            ' --------------------------------- value
            If n > 0 And n <= mMaxDelta Then
                mValue = n
            End If
        End If
        Return mValue
    End Function

    Friend Function ReadDeltaCounts() As Int32
        mNewValue = CInt(Slots.ReadSlot_NoNan(mSlot))
        If mNewValue <> mOldValue Then
            Dim n As Int32 = mValue + mNewValue - mOldValue
            If mNewValue > Limit2 And mOldValue < Limit1 Then n -= Limit3
            If mNewValue < Limit1 And mOldValue > Limit2 Then n += Limit3
            mOldValue = mNewValue
            ' --------------------------------- delta counts
            n = n - mValue
            If n > 0 And n <= mMaxDelta Then
                ReadDeltaCounts = n
                mValue = n
            End If
        End If
    End Function

    Friend Sub Reset()
        mNewValue = CInt(Slots.ReadSlot_NoNan(mSlot))
        mOldValue = mNewValue
        mValue = 0
    End Sub

End Class
