﻿Imports System.Windows.Forms


Class SoundPlayer

    ' ----------------------------------------------------- pan and volume
    'Private mPan As Single
    'Private mVolume As Int32

    ' ----------------------------------------------------- tick params
    Private m_ClickSlot As Int32
    Private m_ClickVolume As Int32 = 0
    Private m_ClickFrequency As Int32 = 10

    ' ----------------------------------------------------- alarm params
    Private m_AlarmVolume As Int32 = 0
    Private m_AlarmFrequency As Int32 = 10

    Private m_AlarmPlaying As Boolean = False
    Private m_AlarmMinimalVolume As Int32 = 0
    Private m_AlarmSample As Int32
    Private m_AlarmLength As Int32
    Private m_AlarmRepetition As Int32

    ' ----------------------------------------------------- buffer
    Private BUFFER_SIZE_BYTES As Int32 = 1024
    Private BUFFERS_COUNT As Int32 = 6
    Private mPlayBuffer As Int16()
    Private mFloatBuffer As Single()
    Private mBufferFillTimeMicrosec As Int32

    ' ----------------------------------------------------- out device
    Private mOutDevice As Int32 = -1
    Private mStereo As Boolean = False
    Private mSampleRate As Int32 = 44100
    Private kFreq As Single = 2 * CSng(Math.PI) / mSampleRate

    ' ----------------------------------------------------- player
    Private mPlayer As AudioOut = New AudioOut






    ' ================================================================================================
    '  FillBuffer - Int64 VERSION
    ' ================================================================================================
    '   9uS to fill 1024 samples
    '   max audio len = 16 hours ( 44100 Hz )
    ' -------------------------------------------------------------------------
    Private Sub FillBuffer(ByRef mPlayBuffer() As Int16)

        Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()

        Dim freq As Single
        Dim v As Single
        Dim p As Int32
        Dim n As Int32
        Dim i As Int32
        Dim j As Int32

        Dim nSamples As Int32 = mPlayBuffer.Length

        ' ---------------------------------------------------------------------- redim buffer if needed
        If mFloatBuffer Is Nothing OrElse mFloatBuffer.Length <> nSamples Then
            ReDim mFloatBuffer(nSamples - 1)
        End If

        ' ---------------------------------------------------------------------- fill buffer with zero
        For i = 0 To nSamples - 1
            mFloatBuffer(i) = 0
        Next

        ' ---------------------------------------------------------------------- add 1 to 30 clicks
        Static oldn As Int32 = 0
        n = GetDeltaCounts()

        If n > 30 Then n = 30
        If n = 0 And oldn > 1 Then n = oldn \ 2 ' stabilize whith slow masters
        oldn = n

        ' ---------------------------------------------------------------------- reduce volume by nClicks
        Static kv As Single = 5
        ' ------------------------------------ 1
        'If n > kv Then
        '    If n > 3 Then
        '        kv = CSng(n ^ 0.6)
        '    Else
        '        kv += 1.5F
        '    End If
        '    'If kv < 8 Then kv += 1.0F
        'Else
        '    If kv > 1 Then kv -= 0.05F
        'End If
        ' ------------------------------------ 2
        Dim delta As Single = CSng(n ^ 0.6) - kv
        If delta > 0 Then
            kv += delta
        Else
            kv += delta / 100
        End If

        If kv < 1 Then kv = 1

        ' ---------------------------------------------------------------------- add clicks
        If n > 0 Then
            freq = m_ClickFrequency * kFreq
            v = m_ClickVolume / 100.0F / kv

            Dim nSamplesPerCycle As Single = (2.0F * CSng(Math.PI)) / freq
            Dim nClickSamples As Int32 = CInt(CInt(80 / nSamplesPerCycle) * nSamplesPerCycle)
            If nClickSamples > nSamples \ 2 Then nClickSamples = nSamples \ 2

            'Debug.Print(nClickSamples.ToString)

            For i = 1 To n
                p = CInt(Rnd() * (nSamples - nClickSamples))
                For j = 0 To nClickSamples - 1
                    mFloatBuffer(p) += v * CSng(Math.Sin(j * freq))
                    p += 1
                Next
            Next
        End If

        ' ---------------------------------------------------------------------- add alarm beep
        If m_AlarmPlaying Then
            freq = m_AlarmFrequency * kFreq
            v = Math.Max(m_AlarmVolume, m_AlarmMinimalVolume) / 100.0F
            If m_AlarmRepetition > 0 Then
                For j = 0 To nSamples - 1
                    If m_AlarmSample Mod m_AlarmRepetition > m_AlarmRepetition / 2 Then
                        mFloatBuffer(j) += v * CSng(Math.Sin(m_AlarmSample * freq))
                    End If
                    m_AlarmSample += 1
                Next
            Else
                For j = 0 To nSamples - 1
                    mFloatBuffer(j) += v * CSng(Math.Sin(m_AlarmSample * freq))
                    m_AlarmSample += 1
                Next
            End If
            If m_AlarmSample > m_AlarmLength Then
                m_AlarmMinimalVolume = 0
                m_AlarmPlaying = False
            End If
        End If

        ' ---------------------------------------------------------------------- FloatBuffer to PlayBuffer
        For i = 0 To nSamples - 1
            v = mFloatBuffer(i)
            ' ---------------------------------------------------------- hard limit. +1/-1
            If v > 1.0F Then v = 1.0F
            If v < -1.0F Then v = -1.0F
            'v = 0.5F * (Math.Abs(v + 1.0F) - Math.Abs(v - 1.0F))
            ' ---------------------------------------------------------- soft saturation
            'v = 1.5F * v - 0.5F * v * v * v
            mPlayBuffer(i) = CShort(v * Short.MaxValue)
        Next

        mBufferFillTimeMicrosec = CInt(sw1.Elapsed.TotalMilliseconds * 1000)
    End Sub

    Private CtReader As CounterReader

    Private Function GetDeltaCounts() As Int32
        If m_ClickVolume = 0 Then Return 0

        'Static oldc As Int32 = 99999

        'Dim newc As Int32
        'newc = Slots.ReadSlot_Limited_65535(m_ClickSlot)

        '' TODO count
        'If newc = 0 Or newc = 1 Then
        '    newc = oldc
        'End If

        'Dim c As Int32
        'If newc >= oldc Then
        '    c = newc - oldc
        'Else
        '    c = (65535 - oldc) + newc + 1
        'End If
        'If c < 0 Then c = 0

        'oldc = newc

        'Return c


        Return CtReader.ReadDeltaCounts()


    End Function




    ' ================================================================================================
    '  PROPERTIES
    ' ================================================================================================

    Friend Function GetBufferSamplesCount() As Int32
        Return BUFFER_SIZE_BYTES
    End Function

    Friend Function GetBufferFillTimeMicrosec() As Int32
        Return mBufferFillTimeMicrosec
    End Function

    Friend Sub SetOutDevice(ByVal OutDevice As Int32)
        mOutDevice = OutDevice
    End Sub

    Friend Sub SetStereo(ByVal stereo As Boolean)
        mStereo = stereo
    End Sub


    'Friend Property Pan() As Single
    '    Get
    '        Return mPan
    '    End Get
    '    Set(ByVal value As Single)
    '        mPan = value
    '        'If value > 1 Then value = 1
    '        'If value < 0 Then value = 0
    '        'mVolume = CInt(value * 4095)
    '    End Set
    'End Property

    'Friend Property Volume() As Single
    '    Get
    '        Return CSng(Math.Sqrt(mVolume)) / 4095.0F
    '    End Get
    '    Set(ByVal value As Single)
    '        If value > 1 Then value = 1
    '        If value < 0 Then value = 0
    '        mVolume = CInt(value * value * 4095)
    '    End Set
    'End Property

    'Friend Property Frequency() As Single
    '    Get
    '        Return mFreq
    '    End Get
    '    Set(ByVal value As Single)
    '        mFreq = value
    '    End Set
    'End Property

    Friend Sub SetClickSlot(ByVal ClickSlot As Int32)
        m_ClickSlot = ClickSlot
        CtReader = New CounterReader(m_ClickSlot, 500)
    End Sub
    Friend Sub SetClickVolume(ByVal ClickVolume As Int32)
        m_ClickVolume = ClickVolume
    End Sub
    Friend Sub SetClickFrequency(ByVal ClickFrequency As Int32)
        m_ClickFrequency = ClickFrequency
    End Sub

    Friend Sub StartAlarmByLevel()
        If m_AlarmPlaying Then Return
        m_AlarmPlaying = True
        m_AlarmSample = 0
        m_AlarmLength = 20000
        m_AlarmRepetition = 0
    End Sub
    Friend Sub StartAlarmByPrecision()
        m_AlarmPlaying = True
        m_AlarmSample = 0
        m_AlarmLength = 25000
        m_AlarmRepetition = 5000
    End Sub
    Friend Sub StartAlarmByNewMeasure()
        m_AlarmPlaying = True
        m_AlarmMinimalVolume = 20
        m_AlarmSample = 0
        m_AlarmLength = 4000
        m_AlarmRepetition = 4000
    End Sub

    Friend Sub SetAlarmVolume(ByVal AlarmVolume As Int32)
        m_AlarmVolume = AlarmVolume
    End Sub
    Friend Sub SetAlarmFrequency(ByVal AlarmFrequency As Int32)
        m_AlarmFrequency = AlarmFrequency
    End Sub


    ' ================================================================================================
    '  START - STOP
    ' ================================================================================================
    Friend Sub PlayStop()
        mPlayer.OutputOff()
    End Sub

    Friend Sub PlayStart()
        PlayStop()

        If mOutDevice >= WaveNative.OutputDevicesCount Then Return

        ' ---------------------------------------------------- max rate = 64000
        mSampleRate = 44100

        kFreq = 100 * 2 * CSng(Math.PI) / mSampleRate

        mPlayer.OutputOn(mOutDevice, _
                         mSampleRate, _
                         16, _
                         1, _
                         BUFFER_SIZE_BYTES, _
                         BUFFERS_COUNT, _
                         AddressOf FillBuffer)
    End Sub


End Class
