﻿Imports System.Drawing

Public Class Form1

    Private Const MAX_SECONDS As Int32 = 9999

    Private CountsNew As Int32
    Private CountsOld As Int32 = 999999

    Private MeasureIsStarted As Boolean = False
    Private Flag_ShowStartMeasure_VerticalDivision As Boolean = False
    Private InvalidateGraph As Boolean = False
    Private TimeCounter As Int32 = 0
    Private ReadyToLog As Boolean = True
    Private WaitingForMaxTime As Boolean = False
    Private NewSampleMarker As Boolean = False

    Private Average_Seconds As Int32
    Private Scroll_Speed As Int32
    Friend Tube_Sens As Single
    Friend Tube_Bkg As Single
    Friend Tube_DeadTime As Single
    Private Slot_Input As Int32
    Private Slot_Output As Int32

    Private FifoAccumulator As FIFO_INT = Nothing

    Private Counts As Int32
    Private Actual_Precision As Int32
    Private Total_Counts As Int32

    Private CPS As Single
    Private CPM As Single
    Private uSH As Single
    Private uRH As Single
    Private pCi As Single
    Private Bq As Single
    Private uShMaxCandle As Single
    Private uShMinCandle As Single

    Private Smooted_Value As Single

    ' Unused flag (set when CPS period is more than 99% of the tube Dead Time)
    Private MaxCountFlag As Boolean

    Private SP1 As SoundPlayer = Nothing

    ' fifo is filled every 100 mS (10 per second)
    ' 60 x 60 x 24 x 2 = 1 728 000 
    ' Fifo setting = 2 000 000 (more than 2 days) 
    Private GraphicWindowFifo As FIFO_GRAPHIC = New FIFO_GRAPHIC(2000000)


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----------------------------------------------------
        ' Remember to set in the Form Properties:
        '  - Opacity = 0 
        '  - ShowInTaskbar = False 
        ' ----------------------------------------------------
        EventsAreEnabled = False
        ' ----------------------------------------------------
        ToolTips_Init()
        Form3.Hide()
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        '
        ' -------------------------------------------
        FifoAccumulator = New FIFO_INT(MAX_SECONDS)
        FifoAccumulator.Init(0)
        txt_FirSeconds.MaxValue = MAX_SECONDS
        ' -------------------------------------------
        LogToImages_ImageType = "jpg"
        cmb_SensorType.SelectedIndex = 0
        cmb_MeasureUnit.SelectedIndex = 0
        Load_INI()
        SetLocales()
        SetScalesBySensorType()
        Set_Props()
        Combo_SetIndex_FromString(cmb_LogImageType, LogToImages_ImageType)
        EnableDisableLogControls()
        ' ------------------------------------------- winforms timers
        'SchedulerMaxPrecision()
        Timer1sec.Interval = 1000
        Timer1sec.Start()
        Timer100ms.Interval = 100
        Timer100ms.Start()
        ' -------------------------------------------
        If Form1_StartWindowState = FormWindowState.Minimized Then
            OldLocation = Location
            If OldLocation.X = -32000 Then
                OldLocation.X = 0
                OldLocation.Y = 0
            End If
            MinimizeToOutOfScreen()
        Else
            WindowState = Form1_StartWindowState
        End If

        ' -------------------------------------------
        EventsAreEnabled = True
        ' -------------------------------------------

        Me.Text = AppTitleAndVersion()
        '
        If OperatingSystemIsWindows Then
            SP1 = New SoundPlayer()
            SP1.PlayStart()
            SetSoundProps()
        End If
        '
        ' ---------------------------------------------------- show
        Me.ShowInTaskbar = True
        Me.Visible = True
        Me.Activate()
        Forms_FadeTo(1, 300)
        '
        StartThereminoHAL()
        '
        If Form2_VisibleAtStart Then
            Form2.Show(Me)
        Else
            Form2.Show(Me)
            Form2.Visible = False
        End If
        Form2.Opacity = 1
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False ' do not permit to save the ini file ( already saved from form2 )
        Me.Refresh()
        e.Cancel = False
        Timer1sec.Stop()
        Timer100ms.Stop()
        'SchedulerDefaultPrecision()
        StopThereminoHAL()
        If OperatingSystemIsWindows Then
            SP1.PlayStop()
        End If
        Forms_FadeTo(0, 300)
        Me.Refresh()
        ' ---------------------------------- OutToScreen to Minimized
        If Location.X = -32000 Then
            If OldLocation.X = -32000 Then
                OldLocation.X = 0
                OldLocation.Y = 0
            End If
            Me.Location = OldLocation
            Me.WindowState = FormWindowState.Minimized
            Save_INI()
        End If
    End Sub

    Private Sub Form_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
        Form2.SetSnap()
    End Sub

    Private Sub Form_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Exit Sub
        Form2.SetSnap()
    End Sub

    ' =========================================================================
    '  WINDOWS SCHEDULER PRECISION
    ' ========================================================================= 
    Private Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Sub SchedulerMaxPrecision()
        If OperatingSystemIsWindows Then
            timeBeginPeriod(1)
        End If
    End Sub
    Private Sub SchedulerDefaultPrecision()
        If OperatingSystemIsWindows Then
            timeEndPeriod(1)
        End If
    End Sub

    ' =========================================================================
    '   THEREMINO HAL - START STOP
    ' =========================================================================
    Private HalProcess As Process = Nothing
    Private Sub StartThereminoHAL()
        If HalProcess Is Nothing OrElse HalProcess.HasExited Then
            Dim path As String = Application.StartupPath & "\Theremino_HAL.exe"
            If Not My.Computer.FileSystem.FileExists(path) Then
                path = Application.StartupPath & "\Theremino_HAL\Theremino_HAL.exe"
            End If
            If Not My.Computer.FileSystem.FileExists(path) Then Return
            Dim psi As New ProcessStartInfo
            psi.WorkingDirectory = IO.Path.GetDirectoryName(path)
            psi.FileName = path
            HalProcess = Process.Start(psi)
            HalProcess.SynchronizingObject = Me
            ' ----------------------------------------------- Wait HAL really started 
            For i As Int32 = 1 To 100
                SleepMyThread(100)
                HalProcess.Refresh()
                If HalProcess.MainWindowTitle.Contains(".") Then Exit For
            Next
        End If
    End Sub
    Private Sub StopThereminoHAL()
        If HalProcess IsNot Nothing Then
            If HalProcess.HasExited Then
                HalProcess = Nothing
                Return
            End If
            For i As Int32 = 1 To 100
                HalProcess.CloseMainWindow()
                HalProcess.Refresh()
                SleepMyThread(100)
                If HalProcess.HasExited Then
                    HalProcess = Nothing
                    Return
                End If
            Next
            HalProcess.Kill()
            HalProcess = Nothing
        End If
    End Sub


    ' =======================================================================================
    '   StartThereminoHAL - ASYNC START
    ' =======================================================================================
    'Private WithEvents AsyncTimer1 As System.Timers.Timer

    'Private Sub AsyncTimer1_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles AsyncTimer1.Elapsed
    '    AsyncTimer1.Stop()
    '    StartThereminoHAL()
    'End Sub

    'Friend Sub StartThereminoHAL_ASYNC()
    '    If AsyncTimer1 Is Nothing Then
    '        AsyncTimer1 = New System.Timers.Timer
    '        AsyncTimer1.Interval = 1
    '        AsyncTimer1.Start()
    '    End If
    'End Sub

    'Private Sub StartThereminoHAL()
    '    ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
    '    For Each proc As Process In Process.GetProcesses
    '        If proc.ProcessName = "Theremino_HAL" Then Exit Sub
    '    Next
    '    ' ----------------------------------------------------------- try to start it from the "ApplicationPath"
    '    Dim psi As New ProcessStartInfo
    '    psi.WorkingDirectory = Application.StartupPath
    '    psi.FileName = PlatformAdjustedFileName(psi.WorkingDirectory & "\Theremino_HAL.exe")
    '    If FileExists(psi.FileName) Then Process.Start(psi)
    '    ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
    '    For Each proc As Process In Process.GetProcesses
    '        If proc.ProcessName = "Theremino_HAL" Then Exit Sub
    '    Next
    '    ' ----------------------------------------------------------- try to start it from "Programs"
    '    psi.WorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & "\Theremino"
    '    psi.FileName = PlatformAdjustedFileName(psi.WorkingDirectory & "\Theremino_HAL.exe")
    '    If FileExists(psi.FileName) Then Process.Start(psi)
    'End Sub




    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ====================================================================================================
    '   COMBO SENSOR TYPE
    ' ====================================================================================================
    Private Sub cmb_SensorType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.DropDown
        cmb_SensorType.ItemHeight = 16
    End Sub
    Private Sub cmb_SensorType_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.DropDownClosed
        cmb_SensorType.ItemHeight = 12
    End Sub
    Private Sub cmb_SensorType_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.SelectionChangeCommitted
        SetScalesBySensorType()
        Save_INI()
    End Sub

    Private Sub SetScalesBySensorType()
        Select Case cmb_SensorType.Text
            Case "Geiger", "Counter"
                Label_Sens.Text = Label_Sens.Text.Replace("CPS/Bq/l", "CPS/mR/h")
                Label_Background.Text = Label_Background.Text.Replace("CPM", "CPS")
                Label_AlarmLevel.Text = Label_AlarmLevel.Text.Replace("pCi/l", "uS/h")
                GroupBox_RadiationPlot.Text = GroupBox_RadiationPlot.Text.Replace("pCi/l", "uS/h")
                Dim oldindex As Int32 = cmb_MeasureUnit.SelectedIndex
                cmb_MeasureUnit.Items.Clear()
                cmb_MeasureUnit.Items.Add("Sievert")
                cmb_MeasureUnit.Items.Add("Roentgen")
                cmb_MeasureUnit.SelectedIndex = oldindex
                RollingGraph_MeasureUnit = cmb_MeasureUnit.Text
                Replace_GroupBoxRadiationPlot_ScaleUnit(GetMeasureUnitShortString)
                Form2.btn_SievertCurie.Text = "S / h"
                Form2.btn_RoentgenBequerel.Text = "R / h"
            Case "IonChamber"
                Label_Sens.Text = Label_Sens.Text.Replace("CPS/mR/h", "CPS/Bq/l")
                Label_Background.Text = Label_Background.Text.Replace("CPS", "CPM")
                Label_AlarmLevel.Text = Label_AlarmLevel.Text.Replace("uS/h", "pCi/l")
                GroupBox_RadiationPlot.Text = GroupBox_RadiationPlot.Text.Replace("uS/h", "pCi/l")
                Dim oldindex As Int32 = cmb_MeasureUnit.SelectedIndex
                cmb_MeasureUnit.Items.Clear()
                cmb_MeasureUnit.Items.Add("Curie")
                cmb_MeasureUnit.Items.Add("Bequerel")
                cmb_MeasureUnit.SelectedIndex = oldindex
                RollingGraph_MeasureUnit = cmb_MeasureUnit.Text
                Replace_GroupBoxRadiationPlot_ScaleUnit(GetMeasureUnitShortString)
                Form2.btn_SievertCurie.Text = "Curie"
                Form2.btn_RoentgenBequerel.Text = "Bq"
        End Select
        Form2.SetMeterScale()
    End Sub

    Private Sub Replace_GroupBoxRadiationPlot_ScaleUnit(ByVal unit As String)
        Dim s As String = Label_RadiationPlotTitle.Text
        Dim i As Int32 = s.IndexOf("( ")
        If i > 0 Then
            s = s.Substring(0, i + 2) + unit + " )"
            Label_RadiationPlotTitle.Text = s
        End If
    End Sub

    ' =======================================================================================
    '   COMBO LOG IMAGE TYPE
    ' =======================================================================================
    Private Sub cmb_LogImageType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_LogImageType.DropDown
        cmb_LogImageType.ItemHeight = 16
        Combo_SetIndex_FromString(cmb_LogImageType, LogToImages_ImageType)
    End Sub
    Private Sub cmb_LogImageType_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_LogImageType.DropDownClosed
        cmb_LogImageType.ItemHeight = 12
        LogToImages_ImageType = cmb_LogImageType.Text
        Save_INI()
    End Sub

    ' =======================================================================================
    '   COMBO MEASURE UNIT
    ' =======================================================================================
    Private Sub cmb_MeasureUnit_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_MeasureUnit.DropDown
        cmb_MeasureUnit.ItemHeight = 16
        'Combo_SetIndex_FromString(cmb_MeasureUnit, LogToImages_ImageType)
    End Sub
    Private Sub cmb_MeasureUnit_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_MeasureUnit.DropDownClosed
        cmb_MeasureUnit.ItemHeight = 16
        'LogToImages_ImageType = cmb_LogImageType.Text
        SetScalesBySensorType()
        Save_INI()
    End Sub


    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_LoadConfiguration.Click
        LoadConfiguration()
    End Sub
    Private Sub Menu_File_SaveConfigurationAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveConfigurationAs.Click
        SaveConfigurationAs()
    End Sub
    Private Sub Menu_File_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveImage.Click
        SaveImage("ThereminoGeiger_", Me)
    End Sub
    Private Sub Menu_File_SavePlotImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SavePlotImage.Click
        SaveImage("PLOT_", GroupBox_RadiationPlot)
    End Sub
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        Me.Close()
    End Sub

    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub Menu_Tools_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Tools.DropDownOpening
        Menu_Tools_ShowAnalogGauge.Enabled = True
        If Form2.Visible Then
            Menu_Tools_ShowAnalogGauge.Checked = True
        Else
            Menu_Tools_ShowAnalogGauge.Checked = False
        End If
    End Sub
    Private Sub Menu_Tools_ShowAnalogGauge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_ShowAnalogGauge.Click
        If Form2.Visible Then
            Form2.Visible = False
        Else
            Form2.Visible = True
        End If
    End Sub
    Private Sub Menu_Tools_CpmTable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_CpmTable.Click
        If MsgBox("CPM Table for the current sensor will be written in the ""Extra"" folder.", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
            SaveCpmTable()
        End If
    End Sub
    Private Sub Menu_Tools_SoundDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_SoundDefaults.Click
        EventsAreEnabled = False
        txt_ClickVolume.NumericValue = 50
        txt_ClickFrequency.NumericValue = 30
        txt_AlarmVolume.NumericValue = 50
        txt_AlarmFrequency.NumericValue = 10
        txt_AlarmLevel.NumericValue = 10
        Set_Props()
        Save_INI()
        EventsAreEnabled = True
    End Sub
    Private Sub Menu_Tools_AllParamsDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_AllParamsDefaults.Click
        EventsAreEnabled = False
        txt_FirSeconds.NumericValue = 60
        txt_ScrollSpeed.NumericValue = 5
        Menu_Tools_SoundDefaults_Click(sender, e)
        txt_SlotIn.NumericValue = 1
        txt_SlotOut.NumericValue = -1
        Set_Props()
        Save_INI()
        EventsAreEnabled = True
    End Sub
    Private Sub Menu_Tools_AllSensorDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_AllSensorDefaults.Click
        ReinitSensorDataToFactoryDefaults()
        Save_SensorDataFile()
    End Sub

    ' =======================================================================================
    '   MENU SENSOR DATA
    ' =======================================================================================
    Private Sub Menu_SensorType_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_SensorType.DropDownOpening
        Load_SensorDataFile()
        Menu_SensorType.DropDownItems.Clear()
        Dim tsmi As ToolStripMenuItem
        For i As Int32 = 0 To SensorData.GetLength(1) - 1
            '
            tsmi = New ToolStripMenuItem(SensorData(0, i), _
                                         Nothing, _
                                         New EventHandler(AddressOf Menu_SensorType_Subitem_Click))
            '
            Menu_SensorType.DropDownItems.Add(tsmi)
        Next
    End Sub
    Private Sub Menu_SensorType_Subitem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        For i As Int32 = 0 To SensorData.GetLength(1) - 1
            If SensorData(0, i) = sender.ToString Then
                EventsAreEnabled = False
                txt_TubeSens.NumericValue = Val(SensorData(1, i))
                txt_TubeBkg.NumericValue = Val(SensorData(2, i))
                txt_TubeDeadTime.NumericValue = Val(SensorData(3, i))
                Combo_SetIndex_FromString(cmb_SensorType, SensorData(4, i))
                SetScalesBySensorType()
                Set_Props()
                Save_INI()
                EventsAreEnabled = True
            End If
        Next
    End Sub

    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.Select()
            End If
        Next
    End Sub
    Private Sub Menu_Language_Deutsch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Deutsch.Click
        Language = "Deutsch"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_English_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_English.Click
        Language = "English"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Espanol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Espanol.Click
        Language = "Espanol"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Portoguese_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Portoguese.Click
        Language = "Portoguese"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Francais_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Francais.Click
        Language = "Francais"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Italian_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Italian.Click
        Language = "Italian"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Japanese_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_Japanese.Click
        Language = "Jpn"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Chinese_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_Chinese.Click
        Language = "Chinese"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ProgramHelp", ".pdf")
    End Sub
    Private Sub Menu_Help_RadioactiveSamples_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Help_RadioactiveSamples.Click
        OpenLocalizedHelp("RadioactiveSamples")
    End Sub
    Private Sub Menu_Help_RadiationScales_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_RadiationScales.Click
        OpenLocalizedHelp("RadiationScales")
    End Sub
    Private Sub Menu_Help_AmbientalRadiation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_AmbientalRadiation.Click
        OpenLocalizedHelp("AmbientalRadiation", ".pdf")
    End Sub
    Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Isotopes.Click
        OpenLocalizedHelp("Isotopes")
    End Sub
    Private Sub Menu_Help_Procedures_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Procedures.Click
        OpenLocalizedHelp("Procedures")
    End Sub
    Private Sub Menu_Help_ClinicalEffects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ClinicalEffects.Click
        OpenLocalizedHelp("ClinicalEffects")
    End Sub
    Private Sub Menu_Help_GeigerTubes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_GeigerTubes.Click
        OpenLocalizedHelp("GeigerTubes", ".pdf")
    End Sub
    Private Sub Menu_Help_GeigerTubesCase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_GeigerTubesCase.Click
        OpenLocalizedHelp("GeigerTubesCase", ".pdf")
    End Sub
    Private Sub Menu_Help_LND7312_Case_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_LND7312_Case.Click
        OpenLocalizedHelp("LND7312_Case", ".pdf")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & ext)
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub

    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoGeiger_", Me)
    End Sub
    Private Sub ToolStripButton_Run_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButton_Run.CheckedChanged
        If ToolStripButton_Run.Checked Then
            Timer1sec.Enabled = True
            Timer100ms.Enabled = True
        Else
            Timer1sec.Enabled = False
            Timer100ms.Enabled = False
        End If
    End Sub
    Private Sub ToolStripButton_StartMeasure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_StartMeasure.Click
        Form2.ResetMeterValues()
        StartNewMeasure()
        If SP1 IsNot Nothing Then
            SP1.StartAlarmByNewMeasure()
        End If
        GroupBox_RadiationValues.Focus()
    End Sub
    Private Sub StartNewMeasure()
        'If txt_MaxSeconds.NumericValueInteger > 0 Then
        '    Set_Props()
        'End If
        '
        ToolStripButton_Run.Checked = True
        Total_Counts = 0
        MeasureIsStarted = False
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(btn_OutputLinear, _
                        " If ""Linear"" is active (orange)" & vbCr & _
                        " - - - - - - - - - - - - - - - - - - -" & vbCr & _
                        " The output value is a float" & vbCr & _
                        " from 0.0 to 1000000.0" & vbCr & _
                        " The measure unit is:" & vbCr & _
                        " uS/h, uR/h, pCi/l or Bq/m3" & vbCr & _
                        " depending by settings." & vbCr & _
                        vbCr & _
                        " If ""Linear"" is inactive (gray)" & vbCr & _
                        " - - - - - - - - - - - - - - - - - - -" & vbCr & _
                        " The output value is derived" & vbCr & _
                        " from the Analog Meter hand." & vbCr & _
                        " 0 = minimum" & vbCr & _
                        " 1000 = maximum")
        ttp1.SetToolTip(txt_ScrollSpeed, _
                        " Graph length approx." & vbCr & _
                        " (for 600 pix window)" & vbCr & _
                        " - - - - - - - - - - - - - - -" & vbCr & _
                        " 14 = 1 min" & vbCr & _
                        " 13 = 2 min" & vbCr & _
                        " 12 = 5 min" & vbCr & _
                        " 11 = 10 min" & vbCr & _
                        " 10 = 15 min" & vbCr & _
                        "  9 = 20 min" & vbCr & _
                        "  8 = 30 min" & vbCr & _
                        "  7 = 60 min" & vbCr & _
                        "  6 = 2 hours" & vbCr & _
                        "  5 = 3 hours" & vbCr & _
                        "  4 = 6 hours" & vbCr & _
                        "  3 = 12 hours" & vbCr & _
                        "  2 = 24 hours" & vbCr & _
                        "  1 = 3 days" & vbCr & _
                        "  0 = 7 days")
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub buttons_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles _
                                                                        txt_ScrollSpeed.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_FirSeconds.LostFocus, _
                                                                            txt_ScrollSpeed.LostFocus, _
                                                                            txt_PlotScale.LostFocus, _
                                                                            btn_ShowCandlesticks.LostFocus, _
                                                                            txt_UserText.LostFocus, _
                                                                            txt_TubeSens.LostFocus, _
                                                                            txt_TubeBkg.LostFocus, _
                                                                            txt_TubeDeadTime.LostFocus, _
                                                                            txt_SlotIn.LostFocus, _
                                                                            txt_SlotOut.LostFocus, _
                                                                            btn_OutputLinear.LostFocus, _
                                                                            txt_ClickVolume.LostFocus, _
                                                                            txt_ClickFrequency.LostFocus, _
                                                                            txt_AlarmVolume.LostFocus, _
                                                                            txt_AlarmFrequency.LostFocus, _
                                                                            txt_AlarmLevel.LostFocus, _
                                                                            chk_ExportWithHeader.LostFocus, _
                                                                            txt_DecimalSeparator.LostFocus, _
                                                                            txt_FieldSeparator.LostFocus, _
                                                                            txt_LogToFileTime.LostFocus, _
                                                                            btn_LogToFile.LostFocus, _
                                                                            btn_LogFormatCPH.LostFocus, _
                                                                            txt_LogToImagesTime.LostFocus, _
                                                                            btn_LogToImages.LostFocus, _
                                                                            btn_GraphAreaOnly.LostFocus, _
                                                                            btn_LogChangeNames.LostFocus, _
                                                                            btn_SendImagesToFtp.LostFocus, _
                                                                            btn_SendLogFileToFtp.LostFocus, _
                                                                            btn_SendDataToHttp.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub


    ' ================================================================================================
    '   SET PROPERTIES
    ' ================================================================================================
    Private Sub Properties_TextChanged(ByVal sender As Object, _
                                       ByVal e As System.EventArgs) Handles txt_FirSeconds.TextChanged, _
                                                                            txt_TubeSens.TextChanged, _
                                                                            txt_TubeBkg.TextChanged, _
                                                                            txt_TubeDeadTime.TextChanged, _
                                                                            txt_SlotIn.TextChanged, _
                                                                            txt_SlotOut.TextChanged, _
                                                                            txt_ClickVolume.TextChanged, _
                                                                            txt_ClickFrequency.TextChanged, _
                                                                            txt_AlarmVolume.TextChanged, _
                                                                            txt_AlarmFrequency.TextChanged, _
                                                                            txt_AlarmLevel.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    ' --------------------------------------------------------------------- CONTROLS PANEL
    Private Sub ScrollSpeed_TextChanged(ByVal sender As Object, _
                                    ByVal e As System.EventArgs) Handles txt_ScrollSpeed.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
        txt_ScrollSpeed.Refresh()
        'InvalidateGraph = True
        RedrawGraph()
    End Sub
    Private Sub txt_PlotScale_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_PlotScale.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
        txt_PlotScale.Refresh()
        'InvalidateGraph = True
        RedrawGraph()
    End Sub
    Private Sub btn_ShowCandlesticks_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_ShowCandlesticks.CheckedChanged
        If Not EventsAreEnabled Then Return
        InvalidateGraph = True
    End Sub
    Private Sub SetSoundProps()
        If SP1 IsNot Nothing Then
            SP1.SetClickSlot(Slot_Input)
            SP1.SetClickVolume(txt_ClickVolume.NumericValueInteger)
            SP1.SetClickFrequency(txt_ClickFrequency.NumericValueInteger)
            SP1.SetAlarmVolume(txt_AlarmVolume.NumericValueInteger)
            SP1.SetAlarmFrequency(txt_AlarmFrequency.NumericValueInteger)
        End If
    End Sub

    ' --------------------------------------------------------------------- LOG FILE PANEL
    Private Sub txt_LogToFileTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LogToFileTime.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        NextLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_LogToFile_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_LogToFile.CheckedChanged
        If Not EventsAreEnabled Then Return
        LogFile_HeaderRequested = True
        EnableDisableLogControls()
        NextLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_LogFormatCPH_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_LogFormatCPH.ClickButtonArea
        EnableDisableLogControls()
        NextLogTime = DateTime.MinValue
    End Sub

    ' --------------------------------------------------------------------- IMAGES FTP PANEL
    Private Sub txt_LogToImagesTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LogToImagesTime.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        NextImgLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_LogToImages_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_LogToImages.CheckedChanged
        EnableDisableLogControls()
        NextImgLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_SendImagesToFtp_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendImagesToFtp.CheckedChanged
        If Not EventsAreEnabled Then Return
        NextImgLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_SendLogFileToFtp_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendLogFileToFtp.CheckedChanged
        If Not EventsAreEnabled Then Return
        NextImgLogTime = DateTime.MinValue
    End Sub
    Private Sub btn_SendDataToHttp_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendDataToHttp.CheckedChanged
        If Not EventsAreEnabled Then Return
        NextImgLogTime = DateTime.MinValue
    End Sub



    Private Sub Set_Props()
        '
        Scroll_Speed = txt_ScrollSpeed.NumericValueInteger
        RollingGraph_Scale = CSng(txt_PlotScale.NumericValue)
        Tube_Sens = CSng(txt_TubeSens.NumericValue)
        Tube_Bkg = CSng(txt_TubeBkg.NumericValue)
        Tube_DeadTime = CSng(txt_TubeDeadTime.NumericValue)
        Slot_Input = txt_SlotIn.NumericValueInteger
        Slot_Output = txt_SlotOut.NumericValueInteger
        Form2.InputSlot = Slot_Input
        '
        SetSoundProps()
        '
        If txt_AlarmLevel.NumericValue >= 1000 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 100
            txt_AlarmLevel.Increment = 1
            txt_AlarmLevel.RoundingStep = 100
        ElseIf txt_AlarmLevel.NumericValue >= 100 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 10
            txt_AlarmLevel.Increment = 0.1
            txt_AlarmLevel.RoundingStep = 10
        ElseIf txt_AlarmLevel.NumericValue >= 10 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 1
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        ElseIf txt_AlarmLevel.NumericValue >= 1 Then
            txt_AlarmLevel.Decimals = 1
            txt_AlarmLevel.ArrowsIncrement = 0.1
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        Else
            txt_AlarmLevel.Decimals = 2
            txt_AlarmLevel.ArrowsIncrement = 0.01
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        End If
    End Sub

    Private Sub btn_EditFtpData_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_WebSettings.ClickButtonArea
        Form3.ShowDialog(Me)
    End Sub

    Private Sub EnableDisableLogControls()
        If btn_LogToFile.Checked Then
            btn_SendLogFileToFtp.Enabled = True
            btn_LogFormatCPH.Enabled = True
        Else
            btn_SendLogFileToFtp.Enabled = False
            btn_LogFormatCPH.Enabled = False
        End If

        If btn_LogFormatCPH.Checked Then
            chk_ExportWithHeader.Enabled = False
            txt_DecimalSeparator.Enabled = False
            lbl_DecimalSeparator.Enabled = False
            txt_FieldSeparator.Enabled = False
            lbl_FieldSeparator.Enabled = False
        Else
            chk_ExportWithHeader.Enabled = True
            txt_DecimalSeparator.Enabled = True
            lbl_DecimalSeparator.Enabled = True
            txt_FieldSeparator.Enabled = True
            lbl_FieldSeparator.Enabled = True
        End If

        If btn_LogToImages.Checked Then
            Label_ImageFormat.Enabled = True
            cmb_LogImageType.BackColor = Color.AliceBlue
            cmb_LogImageType.Enabled = True
            btn_GraphAreaOnly.Enabled = True
            btn_LogChangeNames.Enabled = True
            btn_SendImagesToFtp.Enabled = True
        Else
            Label_ImageFormat.Enabled = False
            cmb_LogImageType.Enabled = False
            cmb_LogImageType.BackColor = Color.DarkGray
            btn_GraphAreaOnly.Enabled = False
            btn_LogChangeNames.Enabled = False
            btn_SendImagesToFtp.Enabled = False
        End If
    End Sub


    ' =======================================================================================================
    '   VISUALIZE
    ' =======================================================================================================
    Private Sub Visualize()
        If Actual_Precision < 1000 Then
            lbl_Precision.Text = Actual_Precision.ToString & " %"
        Else
            lbl_Precision.Text = "wait .."
        End If

        lbl_Counts.Text = Total_Counts.ToString

        If CPS > 1000 Then
            lbl_CPS.Text = CPS.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        ElseIf CPS > 100 Then
            lbl_CPS.Text = CPS.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        ElseIf CPS > 10 Then
            lbl_CPS.Text = CPS.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
        Else
            lbl_CPS.Text = CPS.ToString("0.000", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
        End If

        Select Case cmb_SensorType.Text
            Case "Geiger", "Counter"
                If uSH >= 100 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uSH >= 10 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uSH >= 1 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                Else
                    'lbl_uSH.Text = uSH.ToString("0.000", System.Globalization.CultureInfo.InvariantCulture)
                    Label_uSh.Text = "nS/h"
                    lbl_uSH.Text = (uSH * 1000).ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                End If

                If uRH >= 100000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 10000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 1000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 100 Then
                    Label_uRh.Text = "uR/h"
                    lbl_uRH.Text = uRH.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                Else
                    Label_uRh.Text = "uR/h"
                    lbl_uRH.Text = uRH.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                End If
            Case "IonChamber"
                ' -------------------------------------------------------------
                ' the variable uSh is used to store pCi/l
                ' -------------------------------------------------------------
                Label_uSh.Text = "pCi/l"
                lbl_uSH.Text = pCi.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                Label_uRh.Text = "Bq/m3"
                lbl_uRH.Text = Bq.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        End Select
    End Sub



    ' =======================================================================================================
    '   READ INPUT
    ' =======================================================================================================
    Private Sub ReadInputSlot()
        CountsNew = CInt(Slots.ReadSlot_Limited_65535(Slot_Input))
    End Sub


    Private Sub ExtractDeltaCounts()
        ' TODO counts
        If CountsNew = 0 Then Return
        If CountsNew <> CountsOld Then
            ' ---------------------------------------------------------------- new sample marker
            NewSampleMarker = True
            ' ---------------------------------------------------------------- counts
            If CountsNew >= CountsOld Then
                Counts = CountsNew - CountsOld
            Else
                Counts = ((65535 - CountsOld) + CountsNew + 1)
            End If
            CountsOld = CountsNew
            If Counts < 0 Then Counts = 0
        Else
            Counts = 0
        End If
    End Sub


    ' =======================================================================================================
    '   FINITE AVERAGE ( FIFO )
    ' =======================================================================================================
    Private Sub FifoAverageToCps()
        ' ------------------------------------------------------------------ effective counts ( without tube counts )
        Dim EffectiveCounts As Int32 = Total_Counts
        EffectiveCounts -= CInt(Average_Seconds * Tube_Bkg)
        'Text = EffectiveCounts.ToString
        ' ------------------------------------------------------------------ calc the actual precision
        If EffectiveCounts > 10000 Then
            Actual_Precision = CInt(20 / EffectiveCounts ^ 0.25)
        ElseIf EffectiveCounts > 100 Then
            Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        ElseIf EffectiveCounts > 1 Then
            Actual_Precision = CInt(2000 / EffectiveCounts)
        Else
            Actual_Precision = 9999
        End If

        'If EffectiveCounts > 100 Then
        '    Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        'ElseIf EffectiveCounts > 1 Then
        '    Actual_Precision = CInt(2000 / EffectiveCounts)
        'Else
        '    Actual_Precision = 9999
        'End If

        'If EffectiveCounts > 1 Then
        '    Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        'Else
        '    Actual_Precision = 9999
        'End If

        ' ------------------------------------------------------------------ change Average_seconds based on MaxSeconds
        If MeasureIsStarted Then
            If WaitingForMaxTime Then
                If Average_Seconds >= txt_FirSeconds.NumericValueInteger Then
                    WaitingForMaxTime = False
                    If SP1 IsNot Nothing Then
                        SP1.StartAlarmByPrecision()
                    End If
                End If
            End If
            '
            If Average_Seconds < txt_FirSeconds.NumericValueInteger Then
                If Average_Seconds < MAX_SECONDS Then
                    Average_Seconds += 1
                End If
            Else
                Average_Seconds = txt_FirSeconds.NumericValueInteger
            End If
            '
            lbl_TotalSeconds.Text = Average_Seconds.ToString
        End If
        If uSH > txt_AlarmLevel.NumericValue Then
            If SP1 IsNot Nothing Then
                SP1.StartAlarmByLevel()
            End If
        End If
        ' ------------------------------------------------------------------ start the measure
        If Not MeasureIsStarted Then
            If Total_Counts > 0 Then
                MeasureIsStarted = True
                Flag_ShowStartMeasure_VerticalDivision = True
                TimeCounter = -1
                WaitingForMaxTime = True
                'FifoAccumulator.Init(0)
                Average_Seconds = 1

                'Total_Counts = 0
                'CPS = 0
                'CPM = 0
                'uRH = 0
                'uSH = 0
                'Smooted_uSh = 0

                'uShMaxValid = 99999
                'uShMinValid = 0

                CountsOld = 999999
                Actual_Precision = 9999
            End If
        End If
        ' ------------------------------------------------------------------ add the value to FIFO
        FifoAccumulator.AddValue(Counts)

        ' -----------------------------------------------------------------------------------------
        '  MAIN CPS
        ' -----------------------------------------------------------------------------------------
        ' ------------------------------------------------------------------ get total from FIFO
        Total_Counts = FifoAccumulator.GetSum(Average_Seconds)
        ' ------------------------------------------------------------------ calc the finite average
        Dim sec As Int32 = Average_Seconds
        If WaitingForMaxTime Then sec -= 1
        If sec < 1 Then sec = 1
        CPS = CSng(Total_Counts / sec)
        ' ------------------------------------------------------------------ DeadTime correction
        CPS = CorrectForDeadTime(CPS)
        ' ------------------------------------------------------------------ infinite smoothing
        'SmoothValue(CPS, CSng(Total_Counts / Average_Seconds), 0.1)
    End Sub

    Friend Function CorrectForTubeBkg(ByVal cps As Single) As Single
        Return cps - Tube_Bkg
    End Function

    Friend Function CorrectForDeadTime(ByVal cps As Single) As Single
        Dim k As Single = 1 - cps * 0.000001F * Tube_DeadTime
        If k < 0.05 Then
            k = 0.05
            MaxCountFlag = True
        Else
            MaxCountFlag = False
        End If
        cps = cps / k
        Return cps
    End Function

    Friend Function CalcMicroRoentgens(ByVal cps As Single) As Single
        Return 1000 * (cps - Tube_Bkg) / Tube_Sens
    End Function
    Friend Function CalcMicroSieverts(ByVal uRH As Single) As Single
        Return uRH / 100
    End Function

    Friend Function CalcPicoCurie(ByVal cps As Single) As Single
        Return (cps - Tube_Bkg) * 1000 / (37 * Tube_Sens)
    End Function
    Friend Function CalcBequerels(ByVal cps As Single) As Single
        Return (cps - Tube_Bkg) * 1000 / Tube_Sens
    End Function
    Private Sub Calc_CpmRoentgenSievertCurieBequerels()
        CPM = CPS * 60
        If cmb_SensorType.Text = "IonChamber" Then
            pCi = CalcPicoCurie(CPS)
            Bq = CalcBequerels(CPS)
            If Bq < 0.1 Then Bq = 0.1
            If pCi < 0.01 Then pCi = 0.01
        Else
            uRH = CalcMicroRoentgens(CPS)
            uSH = CalcMicroSieverts(uRH)
            If uRH < 1 Then uRH = 1
            If uSH < 0.01 Then uSH = 0.01
        End If
    End Sub

    Private Function GetSelectedValue_CurieBqSvRntg() As Single
        Select Case cmb_SensorType.Text
            Case "IonChamber"
                If RollingGraph_MeasureUnit = "Curie" Then
                    Return pCi
                Else
                    Return Bq
                End If
            Case Else
                If RollingGraph_MeasureUnit = "Sievert" Then
                    Return uSH
                Else
                    Return uRH
                End If
        End Select
    End Function



    ' ================================================================================================
    '   LOG TIMED EXECUTION - TIMER 1 - REPETITION = 1 SECOND
    ' ================================================================================================
    Private NextLogTime As DateTime = DateTime.MinValue
    Private NextImgLogTime As DateTime = DateTime.MinValue
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1sec.Tick
        '
        If Not EventsAreEnabled Then Return

        ' ---------------------------------- SLOW TIMER ( 1 second )
        '
        If Slot_Input >= 0 Then
            ExtractDeltaCounts()
            FifoAverageToCps()
            Visualize()
            TimeCounter += 1
            ' ------------------------------------------------------- LogToFile
            If btn_LogToFile.Checked Then
                If Now >= NextLogTime Then
                    ' ---------------------------------------
                    If NextLogTime < Now Then NextLogTime = Now
                    ' ---------------------------------------
                    'Text = NextLogTime.ToString("HH:mm:ss")
                    WriteLogLine()
                    ' --------------------------------------- sync next time
                    Dim t As DateTime = Now
                    t = RoundUp(t, txt_LogToFileTime.NumericValueInteger)
                    NextLogTime = t
                End If
            End If
            ' ------------------------------------------------------- LogToWeb
            If Now >= NextImgLogTime Then
                ' ------------------------------------------- 
                If NextImgLogTime < Now Then NextImgLogTime = Now
                ' ------------------------------------------- ensure correct display times
                DisplayLeftRightTimes()
                ' ------------------------------------------- 
                'Text = NextLogTime.ToString("HH:mm:ss")
                LogImagesAndSendLogsToWeb()
                ' ------------------------------------------- sync next time
                Dim t As DateTime = Now
                t = RoundUp(t, txt_LogToImagesTime.NumericValueInteger * 60)
                NextImgLogTime = t
                'Beep()
            End If
            '
        End If
    End Sub

    Private Sub WriteLogLine()
        If btn_LogFormatCPH.Checked Then
            LogFile_WriteCPH(CPS * 3600)
        Else
            If cmb_SensorType.Text = "IonChamber" Then
                LogFile_WriteData(CPS, pCi, True)
            Else
                LogFile_WriteData(CPS, uSH, False)
            End If
        End If
    End Sub

    Private Sub LogImagesAndSendLogsToWeb()
        If btn_LogToImages.Checked Then
            LogToImages_WriteImage(btn_GraphAreaOnly.Checked)
        End If
        '
        If btn_SendLogFileToFtp.Checked Then
            LogFileSendToFtp_ASYNC()
        End If
        '
        If btn_SendDataToHttp.Checked Then
            If cmb_SensorType.Text = "IonChamber" Then
                SendLastDataToHttp_ASYNC(CPS, pCi)
            Else
                SendLastDataToHttp_ASYNC(CPS, uSH)
            End If
        End If
    End Sub


    ' ================================================================================================
    '   GRAPH TIMED EXECUTION - TIMER 2 - REPETITION = 10 per second
    ' ================================================================================================
    Private Sub Timer2_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer100ms.Tick
        '
        'If Not EventsAreEnabled Then Return
        '
        ' ----------------------------------------------------- Timer test
        'Static sw As Stopwatch = New Stopwatch
        'Text = sw.ElapsedMilliseconds.ToString
        'sw.Reset()
        'sw.Start()

        'Static c As Int32 = 0
        'c += 1
        'Text = c.ToString
        '
        ' ----------------------------------------------------- SLOT INPUT
        If Slot_Input >= 0 Then
            ReadInputSlot()
            Calc_CpmRoentgenSievertCurieBequerels()
            ' ------------------------------------------------- Redraw graph if required
            If InvalidateGraph Then
                Static Counter10Hz As Int32 = 0
                Counter10Hz += 1
                If Counter10Hz > 5 Then
                    Counter10Hz = 0
                    InvalidateGraph = False
                    RedrawGraph()
                End If
            End If
            ' ------------------------------------------------- Plot and Scroll Graph
            PlotScrollingGraph()
        End If
        '
        ' ----------------------------------------------------- SLOT OUTPUT
        If Slot_Output >= 0 Then
            Dim outv As Single
            '
            If btn_OutputLinear.Checked Then
                outv = GetSelectedValue_CurieBqSvRntg()
            Else
                outv = 1000 * Form2.AnalogMeter1.HandPositionNormalized
            End If
            '
            Slots.WriteSlot(Slot_Output, outv)
        End If
    End Sub

    ' TODO
    Private GraphicsLastTime As DateTime = Date.Now
    Private Sub DisplayLeftRightTimes()
        GraphicsLastTime = Date.Now
        Dim displaySec As Single = pbox_ScrollingScope.ClientRectangle.Width / PixelsPerSecond(Scroll_Speed)
        Label_TimeLeft.Text = GraphicsLastTime.AddSeconds(-displaySec).ToString("yyyy/MM/dd HH':'mm':'ss ")
        Label_TimeRight.Text = GraphicsLastTime.ToString("yyyy/MM/dd HH':'mm':'ss ")
    End Sub

    ' =======================================================================================================
    '   SCROLLING GRAPH
    ' =======================================================================================================
    Private Sub PlotScrollingGraph()

        Dim PlotValue As Single
        PlotValue = GetSelectedValue_CurieBqSvRntg()

        SmoothValue(Smooted_Value, PlotValue, 0.1)

        ' ------------------------------------------------------------------------------ candles
        Dim kp As Single = (Actual_Precision + 100) / 100.0F
        uShMaxCandle = PlotValue * kp
        uShMinCandle = PlotValue / kp

        Dim showcandles As Boolean = NewSampleMarker AndAlso _
                                     Actual_Precision < 1000 AndAlso _
                                     btn_ShowCandlesticks.Checked
        NewSampleMarker = False

        If Not MeasureIsStarted Then
            showcandles = False
        End If

        ' ------------------------------------------------------------------------------ vertical divisions
        Static oldTimeCounter As Int32 = 0
        Dim VerticalDivisionLength As Int32 = 0
        If TimeCounter <> oldTimeCounter Then
            ' -------------------------------------------
            DisplayLeftRightTimes()
            ' -------------------------------------------
            If Scroll_Speed > 7 Then
                ' TODO - SCROLL SPEED
                ' --------------------------------------- 8 to 14
                ' 14 = 60 seconds with a 600 pixel window
                ' 13 = 2 min
                ' 12 = 5 min
                ' 11 = 10 min
                ' 10 = 15 min
                ' 9 = 20 min
                ' 8 = 30 min
                ' -----------------------------------------------
                VerticalDivisionLength = 3
                If TimeCounter Mod 5 = 0 Then
                    VerticalDivisionLength = 8
                    If TimeCounter Mod 10 = 0 Then
                        VerticalDivisionLength = 16
                        If TimeCounter = 60 Then
                            TimeCounter = 0
                            VerticalDivisionLength = 20
                        End If
                    End If
                End If
            Else
                ' -------------------------------------- 0 to 7
                ' 7 = 1 h
                ' 6 = 2 h
                ' 5 = 3 h
                ' 4 = 6 h
                ' 3 = 12 h
                ' 2 = 1 day
                ' 1 = 3 days
                ' 0 = 7 days
                ' ----------------------------------------------
                VerticalDivisionLength = 0
                ' --------------------------------------- every minute for 1 hour (60 divisions)
                If Scroll_Speed = 7 Then
                    If TimeCounter Mod 60 = 0 Then
                        VerticalDivisionLength = 8
                    End If
                End If
                ' --------------------------------------- every hour
                If Scroll_Speed < 7 Then
                    If TimeCounter Mod 3600 = 0 Then
                        VerticalDivisionLength = 16
                    End If
                End If
                ' --------------------------------------- every day
                If Scroll_Speed = 0 Then
                    If TimeCounter Mod (3600 * 24) = 0 Then
                        VerticalDivisionLength = 24
                    End If
                End If
            End If
            oldTimeCounter = TimeCounter
        End If
        If Flag_ShowStartMeasure_VerticalDivision Then VerticalDivisionLength = 9999
        Flag_ShowStartMeasure_VerticalDivision = False

        ' ------------------------------------------------------------------------------ add data to fifo
        GraphicWindowFifo.AddElement(Smooted_Value, _
                                     showcandles, _
                                     uShMaxCandle, _
                                     uShMinCandle, _
                                     VerticalDivisionLength)
        ' ------------------------------------------------------------------------------ plot graph
        RollingGraph_PlotGraph(pbox_ScrollingScope, _
                               Scroll_Speed, _
                               Smooted_Value, _
                               showcandles, _
                               uShMaxCandle, _
                               uShMinCandle, _
                               VerticalDivisionLength, _
                               False, _
                               MaxCountFlag)
    End Sub


    'Private Sub Test_FillFifo(ByVal n As Int32)
    '    For i As Int32 = 0 To n
    '        GraphicWindowFifo.AddElement(Smooted_Value, _
    '                                        False, _
    '                                        uShMaxCandle, _
    '                                        uShMinCandle, _
    '                                        10)
    '    Next
    'End Sub

    Private Sub RedrawGraph()
        If Me.WindowState = FormWindowState.Minimized Then Return

        Static working As Boolean = False
        If working Then Return
        working = True
        SetCursor_Hourglass()
        LabelWait.Visible = True
        LabelWait.Refresh()

        ' -------------------------- fill fifo to debug the wait message
        'Test_FillFifo(100000)
        ' --------------------------------------------------------------

        ' ------------------------------------------------------------------ redraw background
        pbox_ScrollingScope.Image = Nothing

        RollingGraph_PlotGraph(pbox_ScrollingScope, _
                               Scroll_Speed, _
                               Smooted_Value, _
                               False, _
                               0, _
                               0, _
                               0, _
                               False)
        ' ------------------------------------------------------------------ redraw single points
        Dim ShowCandles As Boolean
        Dim Value As Single
        Dim MaxCandle As Single
        Dim MinCandle As Single
        Dim VerticalDivisionLength As Int32
        Dim VerticalDivisionColor As Int32
        RedrawSinglePointPositionX = pbox_ScrollingScope.Image.Width - 1
        '
        For i As Int32 = 1 To GraphicWindowFifo.Length - 1
            GraphicWindowFifo.GetElement(i, Value, ShowCandles, MaxCandle, MinCandle, _
                                         VerticalDivisionLength, VerticalDivisionColor)
            If Value = 0 Then Exit For
            If Not btn_ShowCandlesticks.Checked Then ShowCandles = False
            RollingGraph_PlotGraph(pbox_ScrollingScope, _
                                   Scroll_Speed, _
                                   Value, _
                                   ShowCandles, _
                                   MaxCandle, _
                                   MinCandle, _
                                   VerticalDivisionLength, _
                                   True)
            If RedrawSinglePointPositionX <= 1 Then Exit For
        Next
        '
        RollingGraph_OldPositionY = 9999999
        working = False
        SetCursor_Default()
        LabelWait.Visible = False
    End Sub


    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        If Not EventsAreEnabled Then Return
        If FlagSizeChanged Then
            FlagSizeChanged = False
            RedrawGraph()
        End If
    End Sub

    ' ---------------------------------------------------------------------- detect size changed and redraw graph
    Private OldWindowState As FormWindowState
    Private FlagSizeChanged As Boolean = False
    Private Sub Form1_ClientSizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ClientSizeChanged
        If Not EventsAreEnabled Then Return

        If WindowState = OldWindowState Then
            FlagSizeChanged = True
        Else

            'If WindowState <> FormWindowState.Minimized And _
            '   OldWindowState <> FormWindowState.Minimized Then
            '    InvalidateGraph = True
            'End If

            OldWindowState = WindowState
        End If

        ' TODO
        If WindowState = FormWindowState.Minimized Then
            EventsAreEnabled = False
            WindowState = FormWindowState.Normal
            If Location.X = -32000 Then
                If OldLocation.X = -32000 Then
                    OldLocation.X = 0
                    OldLocation.Y = 0
                End If
                Location = OldLocation
                'Form2.SetSnap()
            Else
                OldLocation = Location
                Location = New Point(-32000, -32000)
            End If
            EventsAreEnabled = True
        End If

    End Sub

    Private OldLocation As Point = Location
    Private Sub MinimizeToOutOfScreen()
        WindowState = FormWindowState.Normal
        OldLocation = Location
        Location = New Point(-32000, -32000)
    End Sub

    Private Function GetMeasureUnitShortString() As String
        Select Case RollingGraph_MeasureUnit
            Case "Sievert" : Return "uS/h"
            Case "Roentgen" : Return "uR/h"
            Case "Curie" : Return "pCi/l"
            Case "Bequerel" : Return "Bq/m3"
            Case Else : Return "???"
        End Select
    End Function

    ' TODO
    ' =================================================================================
    '   STATUS BAR INDICATIONS
    ' =================================================================================
    Private Sub pbox_ScrollingScope_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbox_ScrollingScope.MouseLeave
        StatusLabel1.Text = ""
    End Sub
    Private Sub pbox_ScrollingScope_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_ScrollingScope.MouseMove
        Dim displaySec As Single = pbox_ScrollingScope.ClientRectangle.Width / PixelsPerSecond(Scroll_Speed)
        Dim SecondsToNow As Single = displaySec * (1 - CSng(e.X) / pbox_ScrollingScope.ClientRectangle.Width)
        Dim s As String = GraphicsLastTime.AddSeconds(-SecondsToNow).ToString("yyyy/MM/dd HH':'mm':'ss ")
        Dim v As Double = YtoValue(e.Y, pbox_ScrollingScope.Image.Height)
        If v > 1000 Then
            v = RoundToNdigits(v, 3)
        Else
            v = RoundToNdigits(v, 2)
        End If
        StatusLabel1.Text = v.ToString(GCI) + " " + GetMeasureUnitShortString() + "    " + s
    End Sub

End Class